t/README: document more test helpers
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
e1970ce4
JH
37# For repeatability, reset the environment to known value.
38LANG=C
899460f3 39LC_ALL=C
d9bdd39e 40PAGER=cat
e1970ce4 41TZ=UTC
c2116a17
JH
42TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
8ff99e74 44EDITOR=:
d33738d7 45unset VISUAL
18508c39 46unset GIT_EDITOR
e1970ce4
JH
47unset AUTHOR_DATE
48unset AUTHOR_EMAIL
49unset AUTHOR_NAME
50unset COMMIT_AUTHOR_EMAIL
51unset COMMIT_AUTHOR_NAME
28a94f88 52unset EMAIL
e1970ce4
JH
53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54unset GIT_AUTHOR_DATE
29e55cd5
JH
55GIT_AUTHOR_EMAIL=author@example.com
56GIT_AUTHOR_NAME='A U Thor'
6677c466 57unset GIT_COMMITTER_DATE
29e55cd5
JH
58GIT_COMMITTER_EMAIL=committer@example.com
59GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
60unset GIT_DIFF_OPTS
61unset GIT_DIR
892c41b9 62unset GIT_WORK_TREE
e1970ce4
JH
63unset GIT_EXTERNAL_DIFF
64unset GIT_INDEX_FILE
65unset GIT_OBJECT_DIRECTORY
0454dd93 66unset GIT_CEILING_DIRECTORIES
e1970ce4
JH
67unset SHA1_FILE_DIRECTORIES
68unset SHA1_FILE_DIRECTORY
6ceeaee7 69unset GIT_NOTES_REF
894a9d33 70unset GIT_NOTES_DISPLAY_REF
6956f858
TR
71unset GIT_NOTES_REWRITE_REF
72unset GIT_NOTES_REWRITE_MODE
8d0fc48f
SP
73GIT_MERGE_VERBOSITY=5
74export GIT_MERGE_VERBOSITY
29e55cd5
JH
75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 77export EDITOR
e1970ce4 78
886a3907
JH
79# Protect ourselves from common misconfiguration to export
80# CDPATH into the environment
81unset CDPATH
82
5565f47c
BW
83unset GREP_OPTIONS
84
3d5c0cc9 85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
91 ;;
92esac
93
cd3c095c
JH
94# Convenience
95#
96# A regexp to match 5 and 40 hexdigits
97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
e1970ce4
JH
100# Each test should start with something like this, after copyright notices:
101#
102# test_description='Description of this test...
103# This test checks if command xyzzy does the right thing...
104# '
105# . ./test-lib.sh
c2116a17
JH
106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
55db1df0 114 color=t
e1970ce4 115
e1970ce4
JH
116while test "$#" -ne 0
117do
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
886856ab
JH
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
5e2c08c6 123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 125 -h|--h|--he|--hel|--help)
570f3226 126 help=t; shift ;;
e1970ce4
JH
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
1ece1274
PH
129 -q|--q|--qu|--qui|--quie|--quiet)
130 quiet=t; shift ;;
e4597aae
MO
131 --with-dashes)
132 with_dashes=t; shift ;;
55db1df0 133 --no-color)
faa4bc35 134 color=; shift ;;
abb7c7b3 135 --no-python)
7cdbff14
JH
136 # noop now...
137 shift ;;
4e1be63c 138 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 139 valgrind=t; verbose=t; shift ;;
44138559
JS
140 --tee)
141 shift ;; # was handled already
f423ef5f
JK
142 --root=*)
143 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
144 shift ;;
e1970ce4 145 *)
1f729dca 146 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
147 esac
148done
149
55db1df0
PH
150if test -n "$color"; then
151 say_color () {
c2116a17
JH
152 (
153 TERM=$ORIGINAL_TERM
154 export TERM
55db1df0
PH
155 case "$1" in
156 error) tput bold; tput setaf 1;; # bold red
157 skip) tput bold; tput setaf 2;; # bold green
158 pass) tput setaf 2;; # green
159 info) tput setaf 3;; # brown
1ece1274 160 *) test -n "$quiet" && return;;
55db1df0
PH
161 esac
162 shift
5099b99d 163 printf "%s" "$*"
55db1df0 164 tput sgr0
b8eecafd 165 echo
c2116a17 166 )
55db1df0
PH
167 }
168else
169 say_color() {
1ece1274 170 test -z "$1" && test -n "$quiet" && return
55db1df0 171 shift
5099b99d 172 echo "$*"
55db1df0
PH
173 }
174fi
175
176error () {
177 say_color error "error: $*"
6e7b5aaf 178 GIT_EXIT_OK=t
55db1df0
PH
179 exit 1
180}
181
182say () {
183 say_color info "$*"
184}
185
570f3226
MB
186test "${test_description}" != "" ||
187error "Test script did not set test_description."
188
189if test "$help" = "t"
190then
191 echo "$test_description"
192 exit 0
193fi
194
4d9d62fa 195exec 5>&1
e1970ce4
JH
196if test "$verbose" = "t"
197then
198 exec 4>&2 3>&1
199else
200 exec 4>/dev/null 3>/dev/null
201fi
202
203test_failure=0
204test_count=0
41ac414e
JH
205test_fixed=0
206test_broken=0
2d84e9fb 207test_success=0
e1970ce4 208
d998bd4a
ÆAB
209test_external_has_tap=0
210
faa4bc35 211die () {
6e7b5aaf
CB
212 code=$?
213 if test -n "$GIT_EXIT_OK"
214 then
215 exit $code
216 else
217 echo >&5 "FATAL: Unexpected exit with code $code"
218 exit 1
219 fi
faa4bc35
CB
220}
221
6e7b5aaf 222GIT_EXIT_OK=
35641310 223trap 'die' EXIT
41184273 224
02b35660
BD
225# The semantics of the editor variables are that of invoking
226# sh -c "$EDITOR \"$@\"" files ...
227#
228# If our trash directory contains shell metacharacters, they will be
229# interpreted if we just set $EDITOR directly, so do a little dance with
230# environment variables to work around this.
231#
232# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 233# that we're using.
02b35660
BD
234test_set_editor () {
235 FAKE_EDITOR="$1"
236 export FAKE_EDITOR
d33738d7
JN
237 EDITOR='"$FAKE_EDITOR"'
238 export EDITOR
02b35660
BD
239}
240
68cfc6f5
MG
241test_decode_color () {
242 sed -e 's/.\[1m/<WHITE>/g' \
243 -e 's/.\[31m/<RED>/g' \
244 -e 's/.\[32m/<GREEN>/g' \
245 -e 's/.\[33m/<YELLOW>/g' \
246 -e 's/.\[34m/<BLUE>/g' \
247 -e 's/.\[35m/<MAGENTA>/g' \
248 -e 's/.\[36m/<CYAN>/g' \
249 -e 's/.\[m/<RESET>/g'
250}
251
c4f3f551
SB
252q_to_nul () {
253 perl -pe 'y/Q/\000/'
254}
255
256q_to_cr () {
257 tr Q '\015'
258}
259
260append_cr () {
261 sed -e 's/$/Q/' | tr Q '\015'
262}
263
264remove_cr () {
265 tr '\015' Q | sed -e 's/Q$//'
266}
267
04509738
JH
268test_tick () {
269 if test -z "${test_tick+set}"
270 then
21afc41c 271 test_tick=1112911993
04509738
JH
272 else
273 test_tick=$(($test_tick + 60))
274 fi
21afc41c
JH
275 GIT_COMMITTER_DATE="$test_tick -0700"
276 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
277 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
278}
e1970ce4 279
00884968
JS
280# Call test_commit with the arguments "<message> [<file> [<contents>]]"
281#
282# This will commit a file with the given contents and the given commit
283# message. It will also add a tag with <message> as name.
284#
285# Both <file> and <contents> default to <message>.
286
287test_commit () {
e656fc97 288 file=${2:-"$1.t"}
00884968
JS
289 echo "${3-$1}" > "$file" &&
290 git add "$file" &&
291 test_tick &&
292 git commit -m "$1" &&
293 git tag "$1"
294}
295
296# Call test_merge with the arguments "<message> <commit>", where <commit>
297# can be a tag pointing to the commit-to-merge.
298
299test_merge () {
300 test_tick &&
301 git merge -m "$1" "$2" &&
302 git tag "$1"
303}
304
1f553918
JS
305# This function helps systems where core.filemode=false is set.
306# Use it instead of plain 'chmod +x' to set or unset the executable bit
307# of a file in the working directory and add it to the index.
308
309test_chmod () {
310 chmod "$@" &&
311 git update-index --add "--chmod=$@"
312}
313
a7bb3940
JS
314# Use test_set_prereq to tell that a particular prerequisite is available.
315# The prerequisite can later be checked for in two ways:
316#
317# - Explicitly using test_have_prereq.
318#
319# - Implicitly by specifying the prerequisite tag in the calls to
320# test_expect_{success,failure,code}.
321#
322# The single parameter is the prerequisite tag (a simple word, in all
323# capital letters by convention).
324
325test_set_prereq () {
326 satisfied="$satisfied$1 "
327}
328satisfied=" "
329
330test_have_prereq () {
331 case $satisfied in
332 *" $1 "*)
333 : yes, have it ;;
334 *)
335 ! : nope ;;
336 esac
337}
338
886856ab
JH
339# You are not expected to call test_ok_ and test_failure_ directly, use
340# the text_expect_* functions instead.
341
342test_ok_ () {
d5d9de1b 343 test_success=$(($test_success + 1))
5099b99d 344 say_color "" "ok $test_count - $@"
e1970ce4
JH
345}
346
886856ab 347test_failure_ () {
d5d9de1b 348 test_failure=$(($test_failure + 1))
5099b99d 349 say_color error "not ok - $test_count $1"
bf0dd8a8 350 shift
5099b99d 351 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 352 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
353}
354
41ac414e 355test_known_broken_ok_ () {
41ac414e 356 test_fixed=$(($test_fixed+1))
5099b99d 357 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
358}
359
360test_known_broken_failure_ () {
41ac414e 361 test_broken=$(($test_broken+1))
5099b99d 362 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 363}
886856ab
JH
364
365test_debug () {
8e832ebc 366 test "$debug" = "" || eval "$1"
e1970ce4
JH
367}
368
4d9d62fa 369test_run_ () {
b6b0afdc 370 test_cleanup=:
4d9d62fa 371 eval >&3 2>&4 "$1"
b6b0afdc 372 eval_ret=$?
3bf78867 373 eval >&3 2>&4 "$test_cleanup"
57e1538a
ÆAB
374 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
375 echo ""
376 fi
4d9d62fa
PR
377 return 0
378}
379
04ece593 380test_skip () {
8586f98b 381 test_count=$(($test_count+1))
04ece593
JH
382 to_skip=
383 for skp in $GIT_SKIP_TESTS
384 do
8586f98b 385 case $this_test.$test_count in
04ece593
JH
386 $skp)
387 to_skip=t
388 esac
389 done
a7bb3940
JS
390 if test -z "$to_skip" && test -n "$prereq" &&
391 ! test_have_prereq "$prereq"
392 then
393 to_skip=t
394 fi
04ece593
JH
395 case "$to_skip" in
396 t)
55db1df0 397 say_color skip >&3 "skipping test: $@"
5099b99d 398 say_color skip "ok $test_count: # skip $1"
04ece593
JH
399 : true
400 ;;
401 *)
402 false
403 ;;
404 esac
405}
406
e1970ce4 407test_expect_failure () {
a7bb3940 408 test "$#" = 3 && { prereq=$1; shift; } || prereq=
8e832ebc 409 test "$#" = 2 ||
a7bb3940 410 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
04ece593 411 if ! test_skip "$@"
e1970ce4 412 then
41ac414e 413 say >&3 "checking known breakage: $2"
04ece593 414 test_run_ "$2"
41ac414e 415 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 416 then
41ac414e 417 test_known_broken_ok_ "$1"
04ece593 418 else
6e7b5aaf 419 test_known_broken_failure_ "$1"
04ece593 420 fi
e1970ce4 421 fi
7a0cf2d0 422 echo >&3 ""
e1970ce4
JH
423}
424
425test_expect_success () {
a7bb3940 426 test "$#" = 3 && { prereq=$1; shift; } || prereq=
8e832ebc 427 test "$#" = 2 ||
a7bb3940 428 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
04ece593 429 if ! test_skip "$@"
e1970ce4 430 then
04ece593
JH
431 say >&3 "expecting success: $2"
432 test_run_ "$2"
433 if [ "$?" = 0 -a "$eval_ret" = 0 ]
434 then
435 test_ok_ "$1"
436 else
437 test_failure_ "$@"
438 fi
e1970ce4 439 fi
7a0cf2d0 440 echo >&3 ""
e1970ce4
JH
441}
442
d3bfdb75 443test_expect_code () {
a7bb3940 444 test "$#" = 4 && { prereq=$1; shift; } || prereq=
d3bfdb75 445 test "$#" = 3 ||
a7bb3940 446 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
04ece593 447 if ! test_skip "$@"
d3bfdb75 448 then
04ece593
JH
449 say >&3 "expecting exit code $1: $3"
450 test_run_ "$3"
451 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
452 then
453 test_ok_ "$2"
454 else
455 test_failure_ "$@"
456 fi
d3bfdb75 457 fi
7a0cf2d0 458 echo >&3 ""
d3bfdb75
FK
459}
460
fb32c410
LW
461# test_external runs external test scripts that provide continuous
462# test output about their progress, and succeeds/fails on
463# zero/non-zero exit code. It outputs the test output on stdout even
d998bd4a 464# in non-verbose mode, and announces the external script with "# run
fb32c410
LW
465# <n>: ..." before running it. When providing relative paths, keep in
466# mind that all scripts run in "trash directory".
467# Usage: test_external description command arguments...
468# Example: test_external 'Perl API' perl ../path/to/test.pl
469test_external () {
a7bb3940
JS
470 test "$#" = 4 && { prereq=$1; shift; } || prereq=
471 test "$#" = 3 ||
472 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
fb32c410
LW
473 descr="$1"
474 shift
475 if ! test_skip "$descr" "$@"
476 then
477 # Announce the script to reduce confusion about the
478 # test output that follows.
d998bd4a 479 say_color "" "# run $test_count: $descr ($*)"
5ae8030f
JN
480 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
481 # to be able to use them in script
482 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
fb32c410
LW
483 # Run command; redirect its stderr to &4 as in
484 # test_run_, but keep its stdout on our stdout even in
485 # non-verbose mode.
486 "$@" 2>&4
487 if [ "$?" = 0 ]
488 then
d998bd4a
ÆAB
489 if test $test_external_has_tap -eq 0; then
490 test_ok_ "$descr"
491 else
492 say_color "" "# test_external test $descr was ok"
493 test_success=$(($test_success + 1))
494 fi
fb32c410 495 else
d998bd4a
ÆAB
496 if test $test_external_has_tap -eq 0; then
497 test_failure_ "$descr" "$@"
498 else
499 say_color error "# test_external test $descr failed: $@"
500 test_failure=$(($test_failure + 1))
501 fi
fb32c410
LW
502 fi
503 fi
504}
505
506# Like test_external, but in addition tests that the command generated
507# no output on stderr.
508test_external_without_stderr () {
509 # The temporary file has no (and must have no) security
510 # implications.
511 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
512 stderr="$tmp/git-external-stderr.$$.tmp"
513 test_external "$@" 4> "$stderr"
514 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
515 descr="no stderr: $1"
516 shift
d998bd4a 517 say >&3 "# expecting no stderr from previous command"
fb32c410
LW
518 if [ ! -s "$stderr" ]; then
519 rm "$stderr"
d998bd4a
ÆAB
520
521 if test $test_external_has_tap -eq 0; then
522 test_ok_ "$descr"
523 else
524 say_color "" "# test_external_without_stderr test $descr was ok"
525 test_success=$(($test_success + 1))
526 fi
fb32c410
LW
527 else
528 if [ "$verbose" = t ]; then
d998bd4a 529 output=`echo; echo "# Stderr is:"; cat "$stderr"`
fb32c410
LW
530 else
531 output=
532 fi
533 # rm first in case test_failure exits.
534 rm "$stderr"
d998bd4a
ÆAB
535 if test $test_external_has_tap -eq 0; then
536 test_failure_ "$descr" "$@" "$output"
537 else
538 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
539 test_failure=$(($test_failure + 1))
540 fi
fb32c410
LW
541 fi
542}
543
74359821
JH
544# This is not among top-level (test_expect_success | test_expect_failure)
545# but is a prefix that can be used in the test script, like:
546#
547# test_expect_success 'complain and die' '
548# do something &&
549# do something else &&
550# test_must_fail git checkout ../outerspace
551# '
552#
553# Writing this as "! git checkout ../outerspace" is wrong, because
554# the failure could be due to a segv. We want a controlled failure.
555
556test_must_fail () {
557 "$@"
5a269730 558 test $? -gt 0 -a $? -le 129 -o $? -gt 192
74359821
JH
559}
560
fdf1bc48
JN
561# Similar to test_must_fail, but tolerates success, too. This is
562# meant to be used in contexts like:
563#
564# test_expect_success 'some command works without configuration' '
565# test_might_fail git config --unset all.configuration &&
566# do something
567# '
568#
569# Writing "git config --unset all.configuration || :" would be wrong,
570# because we want to notice if it fails due to segv.
571
572test_might_fail () {
573 "$@"
574 test $? -ge 0 -a $? -le 129 -o $? -gt 192
575}
576
82ebb0b6
JK
577# test_cmp is a helper function to compare actual and expected output.
578# You can use it like:
579#
580# test_expect_success 'foo works' '
581# echo expected >expected &&
582# foo >actual &&
583# test_cmp expected actual
584# '
585#
586# This could be written as either "cmp" or "diff -u", but:
587# - cmp's output is not nearly as easy to read as diff -u
588# - not all diff versions understand "-u"
589
590test_cmp() {
591 $GIT_TEST_CMP "$@"
592}
593
3bf78867
JN
594# This function can be used to schedule some commands to be run
595# unconditionally at the end of the test to restore sanity:
596#
597# test_expect_success 'test core.capslock' '
598# git config core.capslock true &&
599# test_when_finished "git config --unset core.capslock" &&
600# hello world
601# '
602#
603# That would be roughly equivalent to
604#
605# test_expect_success 'test core.capslock' '
606# git config core.capslock true &&
607# hello world
608# git config --unset core.capslock
609# '
610#
611# except that the greeting and config --unset must both succeed for
612# the test to pass.
613
614test_when_finished () {
b6b0afdc
JN
615 test_cleanup="{ $*
616 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
3bf78867
JN
617}
618
0509eb21 619# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
620# Usage: test_create_repo <directory>
621test_create_repo () {
622 test "$#" = 1 ||
623 error "bug in the test script: not 1 parameter to test-create-repo"
624 owd=`pwd`
625 repo="$1"
bfdbee98 626 mkdir -p "$repo"
eedf8f97 627 cd "$repo" || error "Cannot setup test environment"
3a048328 628 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
5c94f87e 629 error "cannot run git init -- have you built things yet?"
eedf8f97
CW
630 mv .git/hooks .git/hooks-disabled
631 cd "$owd"
632}
a6080a0a 633
e1970ce4 634test_done () {
6e7b5aaf 635 GIT_EXIT_OK=t
2d84e9fb
SR
636 test_results_dir="$TEST_DIRECTORY/test-results"
637 mkdir -p "$test_results_dir"
bba2a7b2 638 test_results_path="$test_results_dir/${0%.sh}-$$"
2d84e9fb
SR
639
640 echo "total $test_count" >> $test_results_path
641 echo "success $test_success" >> $test_results_path
642 echo "fixed $test_fixed" >> $test_results_path
643 echo "broken $test_broken" >> $test_results_path
644 echo "failed $test_failure" >> $test_results_path
645 echo "" >> $test_results_path
41ac414e
JH
646
647 if test "$test_fixed" != 0
648 then
5099b99d 649 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
650 fi
651 if test "$test_broken" != 0
652 then
5099b99d 653 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
654 msg="remaining $(($test_count-$test_broken)) test(s)"
655 else
656 msg="$test_count test(s)"
41ac414e 657 fi
e1970ce4 658 case "$test_failure" in
10b94e28 659 0)
5099b99d
ÆAB
660 # Maybe print SKIP message
661 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
662
d998bd4a
ÆAB
663 if test $test_external_has_tap -eq 0; then
664 say_color pass "# passed all $msg"
665 say "1..$test_count$skip_all"
666 fi
abc5d372
JS
667
668 test -d "$remove_trash" &&
669 cd "$(dirname "$remove_trash")" &&
670 rm -rf "$(basename "$remove_trash")"
671
e1970ce4
JH
672 exit 0 ;;
673
674 *)
d998bd4a
ÆAB
675 if test $test_external_has_tap -eq 0; then
676 say_color error "# failed $test_failure among $msg"
677 say "1..$test_count"
678 fi
5099b99d 679
e1970ce4
JH
680 exit 1 ;;
681
682 esac
683}
684
685# Test the binaries we have just built. The tests are kept in
9adefee5 686# t/ subdirectory and are run in 'trash directory' subdirectory.
2d84e9fb 687TEST_DIRECTORY=$(pwd)
e4597aae 688if test -n "$valgrind"
4e1be63c 689then
4e1be63c
JS
690 make_symlink () {
691 test -h "$2" &&
692 test "$1" = "$(readlink "$2")" || {
693 # be super paranoid
694 if mkdir "$2".lock
695 then
696 rm -f "$2" &&
697 ln -s "$1" "$2" &&
698 rm -r "$2".lock
699 else
700 while test -d "$2".lock
701 do
702 say "Waiting for lock on $2."
703 sleep 1
704 done
705 fi
706 }
707 }
708
709 make_valgrind_symlink () {
710 # handle only executables
711 test -x "$1" || return
712
713 base=$(basename "$1")
714 symlink_target=$TEST_DIRECTORY/../$base
715 # do not override scripts
716 if test -x "$symlink_target" &&
717 test ! -d "$symlink_target" &&
718 test "#!" != "$(head -c 2 < "$symlink_target")"
719 then
720 symlink_target=../valgrind.sh
721 fi
efd92ffd
JS
722 case "$base" in
723 *.sh|*.perl)
724 symlink_target=../unprocessed-script
725 esac
4e1be63c
JS
726 # create the link, or replace it if it is out of date
727 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
728 }
729
730 # override all git executables in TEST_DIRECTORY/..
731 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
732 mkdir -p "$GIT_VALGRIND"/bin
733 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
734 do
735 make_valgrind_symlink $file
736 done
efd92ffd
JS
737 OLDIFS=$IFS
738 IFS=:
739 for path in $PATH
740 do
741 ls "$path"/git-* 2> /dev/null |
742 while read file
743 do
744 make_valgrind_symlink "$file"
745 done
746 done
747 IFS=$OLDIFS
4e1be63c
JS
748 PATH=$GIT_VALGRIND/bin:$PATH
749 GIT_EXEC_PATH=$GIT_VALGRIND/bin
750 export GIT_VALGRIND
e4597aae
MO
751elif test -n "$GIT_TEST_INSTALLED" ; then
752 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
753 error "Cannot run git from $GIT_TEST_INSTALLED."
754 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
755 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
756else # normal case, use ../bin-wrappers only unless $with_dashes:
757 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
758 if ! test -x "$git_bin_dir/git" ; then
759 if test -z "$with_dashes" ; then
760 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
761 fi
762 with_dashes=t
763 fi
764 PATH="$git_bin_dir:$PATH"
765 GIT_EXEC_PATH=$TEST_DIRECTORY/..
766 if test -n "$with_dashes" ; then
767 PATH="$TEST_DIRECTORY/..:$PATH"
768 fi
4e1be63c 769fi
8683a45d 770GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
8bfa6bd6 771unset GIT_CONFIG
8bfa6bd6
JK
772GIT_CONFIG_NOSYSTEM=1
773GIT_CONFIG_NOGLOBAL=1
774export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
49ccb087 775
ac10a857
JK
776. ../GIT-BUILD-OPTIONS
777
5e87eae9
JH
778if test -z "$GIT_TEST_CMP"
779then
780 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
781 then
782 GIT_TEST_CMP="$DIFF -c"
783 else
784 GIT_TEST_CMP="$DIFF -u"
785 fi
786fi
787
6fcca938
PB
788GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
789export GITPERLLIB
eea42069
JH
790test -d ../templates/blt || {
791 error "You haven't built things yet, have you?"
792}
e1970ce4 793
ac10a857 794if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63
SR
795then
796 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
797 export GITPYTHONLIB
798 test -d ../git_remote_helpers/build || {
799 error "You haven't built git_remote_helpers yet, have you?"
800 }
801fi
802
56cf9806
EW
803if ! test -x ../test-chmtime; then
804 echo >&2 'You need to build test-chmtime:'
805 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
806 exit 1
807fi
808
e1970ce4 809# Test repository
abc5d372 810test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
811test -n "$root" && test="$root/$test"
812case "$test" in
813/*) TRASH_DIRECTORY="$test" ;;
814 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
815esac
91c8b825 816test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 817rm -fr "$test" || {
6e7b5aaf 818 GIT_EXIT_OK=t
8d14ac94
JH
819 echo >&5 "FATAL: Cannot prepare test area"
820 exit 1
821}
822
4a7aaccd 823test_create_repo "$test"
1bd9c648
LW
824# Use -P to resolve symlinks in our working directory so that the cwd
825# in subprocesses like git equals our $PWD (for pathname comparisons).
826cd -P "$test" || exit 1
04ece593 827
d5d9de1b
JS
828this_test=${0##*/}
829this_test=${this_test%%-*}
04ece593
JH
830for skp in $GIT_SKIP_TESTS
831do
832 to_skip=
833 for skp in $GIT_SKIP_TESTS
834 do
835 case "$this_test" in
836 $skp)
837 to_skip=t
838 esac
839 done
840 case "$to_skip" in
841 t)
55db1df0
PH
842 say_color skip >&3 "skipping test $this_test altogether"
843 say_color skip "skip all tests in $this_test"
04ece593
JH
844 test_done
845 esac
846done
f17e9fbb 847
8648732e
BC
848# Provide an implementation of the 'yes' utility
849yes () {
850 if test $# = 0
851 then
852 y=y
853 else
854 y="$*"
855 fi
856
857 while echo "$y"
858 do
859 :
860 done
861}
862
f17e9fbb
JS
863# Fix some commands on Windows
864case $(uname -s) in
865*MINGW*)
866 # Windows has its own (incompatible) sort and find
867 sort () {
868 /usr/bin/sort "$@"
869 }
870 find () {
871 /usr/bin/find "$@"
872 }
5397ea31
JS
873 sum () {
874 md5sum "$@"
875 }
4114156a
JS
876 # git sees Windows-style pwd
877 pwd () {
878 builtin pwd -W
879 }
ee9fb68c 880 # no POSIX permissions
6fd1106a 881 # backslashes in pathspec are converted to '/'
fb9a2bea 882 # exec does not inherit the PID
ee9fb68c
JS
883 ;;
884*)
885 test_set_prereq POSIXPERM
6fd1106a 886 test_set_prereq BSLASHPSPEC
fb9a2bea 887 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
888 ;;
889esac
704a3143 890
1b19ccd2 891test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 892test -z "$NO_PYTHON" && test_set_prereq PYTHON
1b19ccd2 893
704a3143
JS
894# test whether the filesystem supports symbolic links
895ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
896rm -f y